//====================================================
// Interconexin y cdigo
// Introduccin a la msica por computadora en red
// Hernani Villaseor, 2014
// Centro Multimedia del CENART, Mxico DF
// hernani.vr@gmail.com
//====================================================

// Busca estos caracteres en el teclado
~ tilde
() parentesis
[] corchetes
{} llaves
|| pipes

// Para evaluar cdigo nos ponemos en la linea que deseamos evaluar y presionamos una combinacin de teclas la cual cambiar segn cada sistema operativo, por ejemplo en Emacs es Cc Cc, en Mac shift + enter

// prendemos el servidor declarando la siguiente linea
s.boot;

// Declaramos esta linea de cdigo para obtener nuestro primer sonido

// Hola mundo !
{SinOsc.ar(410,0,0.5)}.play

// Para parar el sonido, en Mac presionamos las teclas cmd + "punto" en Emacs Cc Cs

// Usamos la JITLib con Ndef. (Node definition) para acceder a proxies que nos permitan reprogramar en tiempo real
// Proxy es un contenedor que puede ser evaluado antes de tener una funcionalidad
// DISCUSIN: programacin en tiempo real

Ndef(\hola).play // toca algo que an no ha sido definido
Ndef(\hola, {SinOsc.ar(300,0,0.5)}) // suena una onda sinoidal
Ndef(\hola).stop

Ndef(\hola, {SinOsc.ar(700,0,0.5)}) // cambia el argumento de frecuencia, el valor de 700
Ndef(\hola).fadeTime=5 // crea un tiempo de desvanecimiento
Ndef(\hola).release // para momentaneamente el Nodo
Ndef(\hola).send // lo manda de nuevo

// Declaracin de argumentos

Ndef(\hola, {|freq=300| SinOsc.ar(freq,0,0.5)})
Ndef(\hola).set(\freq, 200) // cambia el valor con el mensaje .set
Ndef(\hola).xset(\freq, 220) // cambia el valor desde con el tiempo de desvanecimiento

// Ndef con envolvente: comportamiento de la seal en el tiempo
// Con .plot podemos ver el envolvente ej. Env.perc(0.01,0.9).plot

Ndef(\hola, {|frec=400| SinOsc.ar(frec,0,1) * EnvGen.kr(Env.perc(0.01,0.9), doneAction:2)})
Ndef(\hola).spawn // retrigger

// intentar cambiar SinOsc por otros UGens, consulta la ayuda de SuperCollider para ver como funcionan
Saw, Pulse, LFTri, WhiteNoise, PinkNoise

// Multicanal: dos canales
// Cada frecuencia suena en una bocina
// Mas de dos frecuencias se envuelven (wrap) [300, 600, 900]
Ndef(\hola, {|f1=400, f2=407| SinOsc.ar([f1, f2],0,0.5)})

// Distribuir la seal en el campo estreo con un Pan2
Ndef(\hola,{|freq=300| Pan2.ar(SinOsc.ar(freq,0,0.5))})
Ndef(\hola).stop

// Mensajes OSC
// DISCUSIN: concepto de enviar y recibir (responder)
// El mensaje osc se compone de una etiqueta y un valor (nmero o palabra), el cual se enva a una direccin IP y a un puerto de programa empaquetado en un array

// NetAddr -> OSCdef

// Ejercicio 1 envio y recepcin de datos de manera interna

// Con el objeto NetAddr abrimos la posibilidad de enviar datos osc, colocamos la direccin IP interna que siempre es 127.0.0.1 y el puerto del programa, que en el caso de SuperCollider es 57120

// NetAddr envia datos
m=NetAddr("127.0.0.1", 57120)
m.ip

// OSCdef responde a los mensajes entrantes, es decir escucha o recibe los mensajes
// esta compuesto por el nombre, una funcin, una etiqueta y el IP de quien recibe
o=OSCdef(\prueba, {|msg, time, addr, recvPort|}, '/etiqueta');

// con el mtodo .sendMsg podemos enviar los mensajes osc, colocamos la etiqueta y el valor o palabra. La etiqueta es un identificador con el que direccionamos el valor a un objeto que escucha, en este caso OSCdef

m.sendMsg("/etiqueta", "hola")
m.sendMsg("/etiqueta", 4)

// Para ver los que escucha el OSCdef imprimimos todo
o=OSCdef(\prueba, {|msg, time, addr, recvPort| msg.postln; 
	time.postln; addr.postln; recvPort.postln}, '/etiqueta');
	
// Mandamos un mensaje y leemos en la post
m.sendMsg("/etiqueta", 444.78)
	
// imprime solo el indice 1 del mensaje, o sea el valor
o=OSCdef(\prueba, {|msg, time, addr, recvPort| msg[1].postln;}, '/etiqueta');

// Mandamos un mensaje y leemos en la post, recibimos solo el valor
m.sendMsg("/etiqueta", 679.5)

//DISCUSIN: conversacin con algoritmos

// Ejercicio 2 envio y recepcin de datos de manera externa

// Nos conectamos a una red cableada o inalmbrica. Realiza las siguientes tareas:

// 1 identifica la direccin IP de tu computadora asignada por la red a la que te conectaste
// 2 manda datos con una etiqueta a tu compaero, quien debe tener la misma etiqueta para recibir

// sustituye "127.0.0.1" por la direccion IP de tu compaero
n = NetAddr("127.0.0.1", 57120)

// manda un mensaje con un valor
n.sendMsg("/etiqueta", 500)

// manda un mensaje con un palabra
n.sendMsg("/etiqueta", "hola")

// recibe el mensaje
// para recibir el mensaje necesitas crear un OSCdef con la etiqueta con la que envia tu compaero
o=OSCdef(\recibir, {|msg| msg[1].postln}, '/etiqueta');

// Ejercicio 3 enviar y recibir mensajes OSC con sonido

// A nuestro OSCdef le incluimos un sonido mediante el objeto Ndef
// Creamos un Ndef dentro del OSCdef

Ndef(\primero).play

o=OSCdef(\recibir, {|msg|
	Ndef(\primero, {SinOsc.ar(msg[1].postln,0,0.5)})
	}, '/etiqueta');

n.sendMsg("/etiqueta", 680);
n.sendMsg("/etiqueta", 200);

Ndef(\primero).release

// para mandar dos valores modificaremos el codigo de OSC y del Ndef
Ndef(\segundo).play

o=OSCdef(\recibir, {|msg|
	Ndef(\segundo, {SinOsc.ar(msg[1].postln,0,0.5)*LFNoise0.ar(msg[2].postln)})
	}, '/etiqueta');
	
n.sendMsg("/etiqueta", 480, 10);
n.sendMsg("/etiqueta", 280, 5);
Ndef(\segundo).release

// History es una clase que usaremos para comunicarnos en la red

History.makeWin

// presionamos start para comenzar a generar la Historia en la ventana o declaramos
History.start

// Observamos que el cdigo declarado aparece en la ventana junto con el identificador de la persona que lo gener
Ndef(\history).play
Ndef(\history, {Saw.ar(400,0.1)})
Ndef(\history).stop

// Si declaramos una linea de cdigo en la ventana de History se abre la ventana History repeats y posteriormente podemos modificar ese cdigo y volverlo a declarar
// Podemos chatear ya que la ventana de History se comporta como una especie de chat

// presionamos end para dejar de registrar la Historia o declaramos
History.end

// Para ver el resultado declaramos
History.document

// para salvar este documento escoge una ruta en tu computadora
History.saveStory(ruta)

// para leerlo nuevamente buscalo en la ruta donde lo salvaste
History.loadStory(ruta)

// para reproducirlo
History.play

HistoryGui.help;

// Cdigo por Julian Rohrhuber y Alberto de Campo para establecer un red en /*vivo*/2012
// Interconexin de varias compus en red, se conectan de manera automtoca a la red
(
q = ();
NetAddr.broadcastFlag = true;
q.addrs = (0..7).collect { |x| 
		NetAddr("255.255.255.255", 57120 + x)
};
q.sendAll = { |q ... args|
		q.addrs.do { |addr|
				addr.sendMsg(*args)
		}; ""
}
)

// Historia compartida, cambia la etiqueta \nombre por tu nombre
(
History.start;
History.makeWin;

OSCdef(\hist, { |msg| 
	History.enter(msg[2].asString, msg[1]);
}, \hist).fix;

History.localOff;

History.forwardFunc = { |code| 
	q.sendAll(\hist, \nombre, code);
};
)

// Ahora podrs ver el cdigo de las personas conectadas a la red, puedes copiar cdigo, conversar con las otras personas o proponer algn algortimo que todos puedan usar
// Podemos tocar si necesidad de sincronia pero comunicandonos

// Modelo de improvisacin con patrones y Ndefs usando solts [0]

// inicio el Ndef
Ndef(\hola).play

// programos un sonido
Ndef(\hola)[0]= {|f1=400, f2=403| SinOsc.ar([f1,f2],0,0.5)}

// programo una secuencia con el uso de Patterns, tambin cuantizo la secuencia
Ndef(\hola).quant_(4)[1]=\set -> Pbind(\dur, 1, \f1, Pseq([400,560,401,562], inf), \f2, Pseq([700,600,900],inf))

// Tocar en sincrona con MandelHub
// MandelHub: herramienta creada por Patrick Bogeart para la banda de laptops Benoit and the Mandelbrots nos permite tocar sincronizados mediante el uso de patrones o rutinas pertenecientes a las JITLb (Pdef, Tdef, Ndef etc.)
// MandelHub requiere BenoitLib: https://github.com/cappelnord/BenoitLib
// Instalar BenoitLib en Extensiones de Supercollider

// primero se establece un lider, solo una persona declara este cdigo, cambia "Tutorial-Leader" por tu nombre
m = MandelHub.start("Tutorial-Leader");
m.gui

// luego se unen seguidores, las demas declaran este cdigo menos el lider, cambia "Tutorial-Follower" por tu nombre
MandelHub.join("Tutorial-Follower", action: {m = MandelHub.instance});
m.gui

// Podemos cambiar el tiempo en 10 segundos
m.changeTempo(90/60, 10)

// Para terminar la sesin
m.clear

//=====================================================================================
// Investigacin a futuro
// Utopa: librera de Scott Wilson, descargar de http://github.com/muellmusik/utopia
// Chad McKinney software: OSCthulhu
// Quark Republic: Quarks.gui
// Interconexin con otros programas mediante OSC
// Interconexin con otros dispositivos como telefno mvil o tableta 
//=====================================================================================



